#ifndef	_BRSS_H
#define	_BRSS_H

#include <sys/types.h> // for ssize_t

#define MAX_READ_COUNT		15			// 가져올 포스트 최대 갯수	
#define RBUFFER_SIZE        5000000		// 버퍼 크기
#define TEXT_SIZE			255			// 기본 문자 최대 크기

/** 저장할 태그들 */
#define PTAG_TITLE      	0
#define PTAG_LINK       	1
#define PTAG_DESC       	2
#define PTAG_DATE       	3
#define PTAG_ITEM       	4
#define MAX_PTAG        	5

/** 시간 */
typedef struct
{
	int nYear;
	int nMonth;
	int nDay;

	int nHour;
	int nMin;
} T_DateTime;

/** 블로그 정보 */
typedef struct
{
	char aszTitle[TEXT_SIZE];
	char aszLink[TEXT_SIZE];
	char aszDesc[TEXT_SIZE];
} T_BlogInfo;

/** 포스트 정보 */
typedef struct
{
	char aszTitle[TEXT_SIZE];
	char aszLink[TEXT_SIZE];
	char* pszDescription;

	T_DateTime tTime;
} T_BlogPost;


/** */
class CBlogRss
{
protected:
	int m_nSocket;

	T_BlogInfo m_tBlog;
	T_BlogPost* m_tBlogPosts[MAX_READ_COUNT];

	char* m_pszBuff;
	bool m_bHeadSet;
	int m_nPostCount;

	static char* m_paszTag[MAX_PTAG]; 

	int m_nErrorLine;

public:
	CBlogRss();
	virtual ~CBlogRss();

	bool GetData(const char* pszUrl, const char* pszPath);
	
	T_BlogInfo* GetBlogInfo()					{ return &m_tBlog; }
	T_BlogPost* GetBlogPost(int nPos);
	int GetPostCount()							{ return m_nPostCount; }

	int GetErrorLine()							{ return m_nErrorLine; }

protected:	
	/** 파싱 함수 */
	bool ParseData(const char* pszData);

	bool AddPost();
	bool SetPostData(int nType, const char* pszValue);
	void SetPostTime(int nPos, const char* pszValue);

	/** Sockect 함수 */
	bool Connect(const char* pszUrl, const char* pszPath);
	
	ssize_t Read(char* pSou, size_t nMaxLen);
	ssize_t Write(const char *pSou, size_t nLength);

	void SetErrorLine(int nLine)				{ m_nErrorLine = nLine; }
};

#endif //_BRSS_
